import { Banner, DismissingAction, ConfirmingAction } from '../types';
/**
 * BannerBuilder
 * @public
 */
export declare class BannerBuilder {
    private dismissingAction;
    private confirmingActions;
    /**
     * Add dismissing action to Banner
     * @public
     * @param dismissingAction - {@link DismissingAction}
     * @returns
     */
    withDismissingAction(dismissingAction: DismissingAction): BannerBuilder;
    /**
     * Add confirming action to Banner
     * @public
     * @param confirmingAction - {@link ConfirmingAction}
     * @returns
     */
    withConfirmingAction(confirmingAction: ConfirmingAction): BannerBuilder;
    /**
     * Build Banner
     * @public
     * @returns Banner
     */
    build(): Banner;
}
/**
 * Get banner builder instance
 * @public
 */
export declare const getBannerBuilder: () => BannerBuilder;
//# sourceMappingURL=banner-builder.d.ts.map