import { Dialog, DismissingAction, ConfirmingAction } from '../types';
/**
 * DialogBuilder class
 * @public
 */
export declare class DialogBuilder {
    private dismissingAction;
    private confirmingActions;
    /**
     * Add dismissing action to Dialog
     * @public
     * @param dismissingAction - {@link DismissingAction}
     * @returns
     */
    withDismissingAction(dismissingAction: DismissingAction): DialogBuilder;
    /**
     * Add confirming action to Dialog
     * @public
     * @param confirmingAction - {@link ConfirmingAction}
     * @returns
     */
    withConfirmingAction(confirmingAction: ConfirmingAction): DialogBuilder;
    /**
     * Build Dialog
     * @public
     * @returns Dialog
     */
    build(): Dialog;
}
/**
 * Returns an instance of DialogBuilder
 * @public
 */
export declare const getDialogBuilder: () => DialogBuilder;
//# sourceMappingURL=dialog-builder.d.ts.map